SystemOrganization addCategory: #BugFinder!

Object subclass: #BugFinder
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinder'!

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:30'!
generator: aRandom
	generator := aRandom.! !

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:28'!
initialize
	generator := Random new.! !

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:29'!
tryUnarySelectors: anInstance
	| exceptions |
	exceptions := OrderedCollection new.
	( ( anInstance class ) selectors select: #isUnary ) do: [ :s |
		[ anInstance perform: s ] on: Exception do: [ :ex | exceptions add: ex ]
	].
	^ exceptions.! !

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:29'!
tryUnarySelectors: anInstance probability: aFloat
	| exceptions |
	exceptions := OrderedCollection new.
	( ( anInstance class ) selectors select: #isUnary ) do: [ :s |
		( generator next > aFloat )
			ifTrue: [
				[ anInstance perform: s ] on: Exception do: [ :ex | exceptions add: ex ]
			].
	].
	^ exceptions.! !
